
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>NPOI 导入Excel和读取Excel / 憋错料</title>

    <meta name="description" content="NPOI 导入Excel和读取Excel 1.整个Excel表格叫做工作表:WorkBook(工作薄),包含的叫页(工作表):Sheet:行:Row:单元格Cell. 2.NPOI是POI的C#版本,NPOI的行和列的index都是从0开始 3.POI读取Excel有两种格式一个是HSSF,另一个是XSSF. HSSF和XSSF的区别如下: HSSF is the POI Project's pure Java implementation of the Excel '97(-2007) file format. XSSF is the">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">NPOI 导入Excel和读取Excel</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>1、整个Excel表格叫做工作表：WorkBook（工作薄），包含的叫页（工作表）：Sheet；行：Row；单元格Cell。</p>
<p>2、NPOI是POI的C#版本，NPOI的行和列的index都是从0开始</p>
<p>3、POI读取Excel有两种格式一个是HSSF，另一个是XSSF。 HSSF和XSSF的区别如下：&nbsp;<br />HSSF is the POI Project‘s pure Java implementation of the Excel ‘97(-2007) file format.&nbsp;<br />XSSF is the POI Project‘s pure Java implementation of the Excel 2007 OOXML (.xlsx) file format.&nbsp;<br />即：HSSF适用2007以前的版本,XSSF适用2007版本及其以上的。</p>
<p>下面是用NPOI读写Excel的例子：ExcelHelper封装的功能主要是把DataTable中数据写入到Excel中，或者是从Excel读取数据到一个DataTable中。</p>
<p>ExcelHelper类：</p>
<pre>using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NPOI.SS.UserModel;
using NPOI.XSSF.UserModel;
using NPOI.HSSF.UserModel;
using System.IO;
using System.Data;

namespace NetUtilityLib
{
    public class ExcelHelper : IDisposable
    {
        private string fileName = null; //文件名
        private IWorkbook workbook = null;
        private FileStream fs = null;
        private bool disposed;

        public ExcelHelper(string fileName)
        {
            this.fileName = fileName;
            disposed = false;
        }

        /// &lt;summary&gt;
        /// 将DataTable数据导入到excel中
        /// &lt;/summary&gt;
        /// &lt;param name="data"&gt;要导入的数据&lt;/param&gt;
        /// &lt;param name="isColumnWritten"&gt;DataTable的列名是否要导入&lt;/param&gt;
        /// &lt;param name="sheetName"&gt;要导入的excel的sheet的名称&lt;/param&gt;
        /// &lt;returns&gt;导入数据行数(包含列名那一行)&lt;/returns&gt;
        public int DataTableToExcel(DataTable data, string sheetName, bool isColumnWritten)
        {
            int i = 0;
            int j = 0;
            int count = 0;
            ISheet sheet = null;

            fs = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.ReadWrite);
            if (fileName.IndexOf(".xlsx") &gt; 0) // 2007版本
                workbook = new XSSFWorkbook();
            else if (fileName.IndexOf(".xls") &gt; 0) // 2003版本
                workbook = new HSSFWorkbook();

            try
            {
                if (workbook != null)
                {
                    sheet = workbook.CreateSheet(sheetName);
                }
                else
                {
                    return -1;
                }

                if (isColumnWritten == true) //写入DataTable的列名
                {
                    IRow row = sheet.CreateRow(0);
                    for (j = 0; j &lt; data.Columns.Count; ++j)
                    {
                        row.CreateCell(j).SetCellValue(data.Columns[j].ColumnName);
                    }
                    count = 1;
                }
                else
                {
                    count = 0;
                }

                for (i = 0; i &lt; data.Rows.Count; ++i)
                {
                    IRow row = sheet.CreateRow(count);
                    for (j = 0; j &lt; data.Columns.Count; ++j)
                    {
                        row.CreateCell(j).SetCellValue(data.Rows[i][j].ToString());
                    }
                    ++count;
                }
                workbook.Write(fs); //写入到excel
                return count;
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception: " + ex.Message);
                return -1;
            }
        }

        /// &lt;summary&gt;
        /// 将excel中的数据导入到DataTable中
        /// &lt;/summary&gt;
        /// &lt;param name="sheetName"&gt;excel工作薄sheet的名称&lt;/param&gt;
        /// &lt;param name="isFirstRowColumn"&gt;第一行是否是DataTable的列名&lt;/param&gt;
        /// &lt;returns&gt;返回的DataTable&lt;/returns&gt;
        public DataTable ExcelToDataTable(string sheetName, bool isFirstRowColumn)
        {
            ISheet sheet = null;
            DataTable data = new DataTable();
            int startRow = 0;
            try
            {
                fs = new FileStream(fileName, FileMode.Open, FileAccess.Read);
                if (fileName.IndexOf(".xlsx") &gt; 0) // 2007版本
                    workbook = new XSSFWorkbook(fs);
                else if (fileName.IndexOf(".xls") &gt; 0) // 2003版本
                    workbook = new HSSFWorkbook(fs);

                if (sheetName != null)
                {
                    sheet = workbook.GetSheet(sheetName);
                    if (sheet == null) //如果没有找到指定的sheetName对应的sheet，则尝试获取第一个sheet
                    {
                        sheet = workbook.GetSheetAt(0);
                    }
                }
                else
                {
                    sheet = workbook.GetSheetAt(0);
                }
                if (sheet != null)
                {
                    IRow firstRow = sheet.GetRow(0);
                    int cellCount = firstRow.LastCellNum; //一行最后一个cell的编号 即总的列数

                    if (isFirstRowColumn)
                    {
                        for (int i = firstRow.FirstCellNum; i &lt; cellCount; ++i)
                        {
                            ICell cell = firstRow.GetCell(i);
                            if (cell != null)
                            {
                                string cellValue = cell.StringCellValue;
                                if (cellValue != null)
                                {
                                    DataColumn column = new DataColumn(cellValue);
                                    data.Columns.Add(column);
                                }
                            }
                        }
                        startRow = sheet.FirstRowNum + 1;
                    }
                    else
                    {
                        startRow = sheet.FirstRowNum;
                    }

                    //最后一列的标号
                    int rowCount = sheet.LastRowNum;
                    for (int i = startRow; i &lt;= rowCount; ++i)
                    {
                        IRow row = sheet.GetRow(i);
                        if (row == null) continue; //没有数据的行默认是null　　　　　　　

                        DataRow dataRow = data.NewRow();
                        for (int j = row.FirstCellNum; j &lt; cellCount; ++j)
                        {
                            if (row.GetCell(j) != null) //同理，没有数据的单元格都默认是null
                                dataRow[j] = row.GetCell(j).ToString();
                        }
                        data.Rows.Add(dataRow);
                    }
                }

                return data;
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception: " + ex.Message);
                return null;
            }
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (!this.disposed)
            {
                if (disposing)
                {
                    if (fs != null)
                        fs.Close();
                }

                fs = null;
                disposed = true;
            }
        }
    }
}</pre>
<p>补充个方法</p>
<pre>  　　　　/// &lt;summary&gt;
        /// 获取单元格的值（读取异常的时候调用）
        /// &lt;/summary&gt;
        /// &lt;param name="Cell"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        private object GetCellValue(ICell Cell)
        {
            object value = null;
            try
            {
                switch (Cell.CellType)
                {
                    case CellType.Blank:
                        value = Cell.StringCellValue;
                        break;
                    case CellType.String:
                        value = Cell.StringCellValue;
                        break;
                    case CellType.Numeric:
                        value = Cell.NumericCellValue.ToString();
                        break;
                    case CellType.Boolean:
                        value = Cell.BooleanCellValue;
                        break;
                    case CellType.Formula:
                        value = Cell.RichStringCellValue;
                        break;
                    case CellType.Error:
                        value = Cell.ErrorCellValue;
                        break;
                    case CellType.Unknown:
                        value = Cell.ToString();
                        break;

                }
            }
            catch (Exception)
            {
                value = System.DBNull.Value;
            }
            return value;
        }</pre>
<p>测试代码：</p>
<pre>using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace NPOIExcelExample
{
    class Program
    {
        static DataTable GenerateData()
        {
            DataTable data = new DataTable();
            for (int i = 0; i &lt; 5; ++i)
            {
                data.Columns.Add("Columns_" + i.ToString(), typeof(string));
            }

            for (int i = 0; i &lt; 10; ++i)
            {
                DataRow row = data.NewRow();
                row["Columns_0"] = "item0_" + i.ToString();
                row["Columns_1"] = "item1_" + i.ToString();
                row["Columns_2"] = "item2_" + i.ToString();
                row["Columns_3"] = "item3_" + i.ToString();
                row["Columns_4"] = "item4_" + i.ToString();
                data.Rows.Add(row);
            }
            return data;
        }

        static void PrintData(DataTable data)
        {
            if (data == null) return;
            for (int i = 0; i &lt; data.Rows.Count; ++i)
            {
                for (int j = 0; j &lt; data.Columns.Count; ++j)
                    Console.Write("{0} ", data.Rows[i][j]);
                Console.Write("\n");
            }
        }

        static void TestExcelWrite(string file)
        {
            try
            {
                using (ExcelHelper excelHelper = new ExcelHelper(file))
                {
                    DataTable data = GenerateData();
                    int count = excelHelper.DataTableToExcel(data, "MySheet", true);
                    if (count &gt; 0)
                        Console.WriteLine("Number of imported data is {0} ", count);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception: " + ex.Message);
            }
        }

        static void TestExcelRead(string file)
        {
            try
            {
                using (ExcelHelper excelHelper = new ExcelHelper(file))
                {
                    DataTable dt = excelHelper.ExcelToDataTable("MySheet", true);
                    PrintData(dt);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Exception: " + ex.Message);
            }
        }

        static void Main(string[] args)
        {
            string file = "..\\..\\myTest.xlsx";
            TestExcelWrite(file);
            TestExcelRead(file);
        }
    }
}</pre>
<p>补充调用方法：</p>
<pre> 　　　　　　HttpPostedFileBase excelFile = Request.Files["fileName"]; //取到上传域
            if (null != excelFile)
            {
                string fileName = Path.GetFileName(excelFile.FileName); //取到文件的名称

                excelFile.SaveAs(Server.MapPath("~/Upload/") + System.IO.Path.GetFileName(excelFile.FileName));
                string a = Server.MapPath("~/Upload/" + fileName);
                ExcelHelper eh = new ExcelHelper(a);

                if (fileName.Equals("") || null == fileName)
                { //没有选择文件就上传的话，则跳回到上传页面
                    return false;
                }&nbsp; 　　　　　　ExcelHelper eh = new ExcelHelper(a);</pre>
<p>参考：http://www.cnblogs.com/luxiaoxun/p/3374992.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-07 15:12:50 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/ror/" title="ror">ror</a>, <a href="https://www.biecuoliao.com/tag/www/" title="www&period;">www&period;</a>, <a href="https://www.biecuoliao.com/tag/%e5%8f%a6%e4%b8%80%e4%b8%aa/" title="另一个">另一个</a>, <a href="https://www.biecuoliao.com/tag/res/" title="res">res</a>, <a href="https://www.biecuoliao.com/tag/sum/" title="sum">sum</a>, <a href="https://www.biecuoliao.com/tag/post/" title="&period;post">&period;post</a>, <a href="https://www.biecuoliao.com/tag/toe/" title="toe">toe</a>, <a href="https://www.biecuoliao.com/tag/%e5%8f%96%e6%95%b0/" title="取数">取数</a>, <a href="https://www.biecuoliao.com/tag/switch/" title="switch">switch</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>NPOI 导入Excel和读取Excel的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVYR714.html" rel="bookmark">C&num;操作Excel文件&lpar;读取Excel，写入Excel&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看到论坛里面不断有人提问关于读取excel和导入excel的相关问题.闲暇时间将我所知道的对excel的操作加以总结,如今共享大家,希望给大家可以给大家带了一定的帮助.另外我们还要注意一些简单的问题1.excel文件仅仅能存储65535行数据,假设你的数据大于65535行,那么就须要将excel切割存放了.2.关于乱码,这主要是字符设置问题. 1.载入Excel(读取excel内容)返回值是一个DataSet //载入Excel public static DataSet LoadDataFro			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoL6Ab0.html" rel="bookmark">c&num;操作excel方式三&colon;使用Microsoft&period;Office&period;Interop&period;Excel&period;dll读取Excel文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.引用Microsoft.Office.Interop.Excel.dll 2.引用命名空间.使用别名 [csharp] view plaincopy using System.Reflection; using Excel = Microsoft.Office.Interop.Excel; 3.写入excel 写入函数 [csharp] view plaincopy public void ToExcel(string strTitle) { int nMax = 9; int nMin =			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGAB1a3.html" rel="bookmark">java生成excel和读取excel例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于使用java的操作excel的方法有很多种,我的http://blog.csdn.net/qq_20545159/article/details/45132041价绍过,下面是使用jxl生成xls格式的excel简单的代码. 使用jxl生成excel文件首先必须将jxl.jar的包加到你的项目的路径下. package com.silence.excel; import java.io.File; import jxl.Workbook; import jxl.write.Label; im			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/387apZ0.html" rel="bookmark">NPOI 导入为table 处理excel 格式问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ICell cell = row.GetCell(j); if (!cell.isDbNullOrNull()) { switch (cell.CellType) { case CellType.Blank: dataRow[j] = string.Empty; break; case CellType.Boolean: dataRow[j] = cell.BooleanCellValue; break; case CellType.Numeric: if (DateUtil.IsCellDat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6Na6XM.html" rel="bookmark">NPOI读取Excel，导入数据到Excel练习01</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				NPOI 2.2.0.0,初级读取导入Excel 1.读取Excel,将数据绑定到dgv上 1 private void button1_Click(object sender, EventArgs e) 2 { 3 List&lt;Book&gt; books = new List&lt;Book&gt;(); 4 //1.读取Excel文件 5 using (FileStream fsReder = File.OpenRead(&quot;练习.xlsx&quot;)) 6 { 7 //2.创建工作簿			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ObPb70.html" rel="bookmark">C&num;读取excel等表格常用方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				0. 利用NPOI. 请查阅此插件的相关文档. 1.方法一:采用OleDB读取EXCEL文件: 把EXCEL文件当做一个数据源来进行数据的读取操作,实例如下: 1 2 3 4 5 6 7 8 9 10 11 12 13 14 public DataSet ExcelToDS(string Path) { string strConn = &quot;Provider=Microsoft.Jet.OLEDB.4.0;&quot; +&quot;Data Source=&quot;+ Path +&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eqy7w0.html" rel="bookmark">C&num; 读取EXCEL文件的三种经典方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.方法一:采用OleDB读取EXCEL文件: 把EXCEL文件当做一个数据源来进行数据的读取操作,实例如下: public DataSet ExcelToDS(string Path) { string strConn = &quot;Provider=Microsoft.Jet.OLEDB.4.0;&quot; +&quot;Data Source=&quot;+ Path +&quot;;&quot;+&quot;Extended Properties=Excel 8.0;&quot;; OleDb			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nPj2V4.html" rel="bookmark">C&num; 读取EXCEL文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.方法一:采用OleDB读取EXCEL文件: 把EXCEL文件当做一个数据源来进行数据的读取操作,实例如下: 1 2 3 4 5 6 7 8 9 10 11 12 13 14 public DataSet ExcelToDS(string Path) { string strConn = &quot;Provider=Microsoft.Jet.OLEDB.4.0;&quot; +&quot;Data Source=&quot;+ Path +&quot;;&quot;+&quot;Extended P			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jrdBZ0.html" rel="bookmark">C&num;读取Excel的其中一种方式OleDb读取（100万条）--快速大量插入SQL中</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主要运用表类型 1 Create table BulkTestTable( 2 Id nvarchar(32), 3 UserName nvarchar(32), 4 Pwd nvarchar(32) 5 ) 6 Go 7 CREATE TYPE BulkUdt AS TABLE 8 (Id nvarchar(32), 9 UserName nvarchar(32), 10 Pwd nvarchar(32) ) C#端读取Excel /// &lt;summary&gt; /// 读取Excel中数据 /			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPOYD4.html" rel="bookmark" class="title">6&period;EVE-NG网卡桥接，带您走进更高级的实验</a>
					<div>
						文章列表(关注微信公众号EmulatedLab,及时获取文章以及下载链接) 1.EVE-NG介绍(EVE-NG最好用的模拟器,仿真环境时代来临!) 2.EVE-NG安装过程介绍 3.EVE-NG导入D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/w3v6LR3.html" rel="bookmark" class="title">FastReport调用Delphi中的自定义函数</a>
					<div>
						//定义一个函数: function SmallToMoney(akey: real): string; begin   //'1234500' end; //此处为fastreport加载自定义函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MVjLwM.html" rel="bookmark" class="title">C&num;中？？操作符和？操作符</a>
					<div>
						C#中??和?操作符如何使用及意思: 为了实现Nullable数据到non-Nullable型数据的转换 ??操作符意思是取所复制??左边的,如果左边的为null,取所赋??右边的 ?是system. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXenQ0.html" rel="bookmark" class="title">Android学习之Drawable（一）</a>
					<div>
						Drawable有很多种,它们表示一种图像概念,但它们不全是图片.Drawable是什么呢?下面是Google Android API中的定义: A Drawable is a general abs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02bboE0.html" rel="bookmark" class="title">git 删除错误提交的commit</a>
					<div>
						转自:http://www.douban.com/note/189603387/ 正好遇到进阶问题.试了一下,是我要的,直接把服务器主版本还原了.不过这样也挺危险的,自己用用还可以. 方法: git  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGQxD3.html" rel="bookmark" class="title">uva 1456&lpar;dp&rpar;</a>
					<div>
						题意:有n个数字u1,u2,u3-un,每个数字出现的概率pi = ui/(u1 + u2 + - + un),分成w组,计算期望值. 第一组样例的五个数字如下 30 5 10 30 25 分成2组  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MywAdV3.html" rel="bookmark" class="title">今日错误：切记</a>
					<div>
						忘记导入					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02mOGzM.html" rel="bookmark" class="title">HDU 5543 Pick The Sticks</a>
					<div>
						背包变形.与普通的背包问题不同的是:允许有两个物品可以花费减半. 因此加一维即可,dp[i][j][k]表示前i个物品,有j个花费减半了,总花费为k的情况下的最优解. #pragma comment( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Ky9py4.html" rel="bookmark" class="title">iPhone学习之秒表</a>
					<div>
						主视图控制器类头文件 #import &lt;UIKit/UIKit.h&gt; //UITextField与文本框相关的方法 @interface MainViewController : UIVi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYBvw3.html" rel="bookmark" class="title">数据结构上机5二叉树遍历</a>
					<div>
						写的不标准,凑活着.(￣o￣) . z Z bitree.h #define OK 1 #define ERROR 0 #define OVERFLOW -2 #define STACK_INIT_S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49bXggM.html" rel="bookmark" class="title">Python之表达式与运算符以及运算优先级</a>
					<div>
						Python的表达式和语句: 表达式:1个或以上的操作数以及0个或以上的操作符组成的序列. 语句:用来实现的操作. 声明变量.赋值语句.控制语句.条件语句....语句在程序中执行的顺序叫做控制     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONkVo0.html" rel="bookmark" class="title">Unsupported major&period;minor version 51&period;0解决办法</a>
					<div>
						问题产生的原因:用jdk7编译的class文件放到基于jdk6运行在tomcat之中,就会报这个错. 解决方法: 项目------&gt;右键------&gt;属性------&gt;Java Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RG1ny3.html" rel="bookmark" class="title">&lbrack;Android&rsqb;继承式UI界面布局设计</a>
					<div>
						一般而言,Android界面布局使用聚合的方式比较多,这种方式要求首先构建一批能够复用的组件,然后在Activity的布局文件中进行聚合.尽管这种方式能够完成组件的复用,但如果这些组件在不同Activ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqa1pM.html" rel="bookmark" class="title">学习XML（添加一个子节点）   摘录</a>
					<div>
						reference:http://blog.csdn.net/you_laner/article/details/1112129 这里介绍添加XML节点的方法. 首先定义XML文件:(bookstor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvrD63.html" rel="bookmark" class="title">&amp;lt&semi;转&amp;gt&semi;How to Encourage Your Child&amp;&num;39&semi;s Interest in Science and Tech</a>
					<div>
						How to Encourage Your Child's Interest in Science and Tech This week's Ask-A-Data-Scientist column i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm9gkKM.html" rel="bookmark" class="title">electron 的窗口设置最大化 最小化</a>
					<div>
						/** * Created by Administrator on 2016/11/23. * 页面对窗口的一些操作封装,用于渲染进程 */ &quot;use strict&quot;; const ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kLeg0.html" rel="bookmark" class="title">骨关节及软组织</a>
					<div>
						骨关节及软组织 一.影像学中骨的分类:长骨.短骨.扁骨.不规则骨 重点一:长骨:骨髓腔 不规则骨:(如椎骨)的椎弓根   扁骨的骨皮质(不可见的骨膜): 儿童骨:骺软骨(CT不可见, MRI可见) 二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJklv3.html" rel="bookmark" class="title">中小型网站网络文件系统-NFS部署搭建</a>
					<div>
						NFS网络文件共享服务 一.NFS介绍 NFS是network file sysfile 的缩写,功能是通过网络让不同的主机之间可以彼此共享文件会目录.NFS客户端(一般为应用服务器,如web)可以通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38ozEA0.html" rel="bookmark" class="title">编程：要求随机产生30到小学2年级的四则运算题</a>
					<div>
						源代码: #include&lt;iostream.h&gt;#include&lt;stdlib.h&gt;#include&lt;time.h&gt;void main(){ int a,i,k, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J9nND3.html" rel="bookmark" class="title">关于 weChat 页面开发过程中遇到的问题总结</a>
					<div>
						1. 页面中不能有 `style` tag, 如果有, 则下面写法的不会调起轮播: &lt;a href=&quot;weixin://viewimage/`YourImageURL`&quot;&g ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
